- name: Setup Gitlab Runner
  hosts: all
  gather_facts: false
  vars:
    gitlab_runner_dm_version: "0.16.2-gitlab.25"
    gitlab_runner_version: "16.9.1-1"
    # gitlab_runner_authorized_keys: [""]
    # gitlab_runner_availability_zone: ""
    # gitlab_runner_token: ""
    # gitlab_runner_openstack_username: ""
    # gitlab_runner_openstack_password: ""
    # gitlab_runner_openstack_tenantid: ""
    # gitlab_runner_openstack_network: ""
    # gitlab_runner_openstack_authurl: ""
    # gitlab_runner_openstack_domainname: ""
    # gitlab_runner_openstack_availabilityzone: ""
  tasks:
    - name: Wait for connection
      ansible.builtin.wait_for_connection:
        sleep: 30
        timeout: 300
    - name: Add authorized keys
      ansible.posix.authorized_key:
        user: ubuntu
        state: present
        key: "{{ lookup('file', 'authorized_keys', split_lines=False) }}"
    - name: Docker Machine version check
      ansible.builtin.shell:
        cmd: "docker-machine --version 2> /dev/null | awk '{print $3}' | awk -F ',$' '{print $1}'"
      register: gitlab_runner_dm_version_installed
    - name: Docker Machine Install (Gitlab Fork)
      become: true
      ansible.builtin.get_url:
        ## Get the latest release here: # https://gitlab.com/gitlab-org/ci-cd/docker-machine/-/releases
        url: "https://gitlab-docker-machine-downloads.s3.amazonaws.com/v{{ gitlab_runner_dm_version }}/docker-machine-Linux-x86_64"
        dest: /usr/local/bin/docker-machine
        mode: "0755"
      when: gitlab_runner_dm_version_installed.stdout != gitlab_runner_dm_version
    - name: Gitlab Runner repository check
      ansible.builtin.stat:
        path: /etc/apt/sources.list.d/runner_gitlab-runner.list
      register: gitlab_runner_repository
    - name: Gitlab Runner repository installation script
      become: true
      ansible.builtin.get_url:
        url: "https://packages.gitlab.com/install/repositories/runner/gitlab-runner/script.deb.sh"
        dest: /opt/gitlab-runner.script.deb.sh
        mode: "0744"
      when: not gitlab_runner_repository.stat.exists
    - name: Gitlab Runner Install repository
      become: true
      ansible.builtin.shell: /opt/gitlab-runner.script.deb.sh
      when: not gitlab_runner_repository.stat.exists
    - name: Gitlab Runner Install
      become: true
      ansible.builtin.apt:
        name: "gitlab-runner={{ gitlab_runner_version }}"
        state: present
    - name: Gitlab Runner Config
      become: true
      ansible.builtin.template:
        src: config.toml.j2
        dest: /etc/gitlab-runner/config.toml
        mode: "0644"
      no_log: true
      register: gitlab_runner_config
    - name: Gitlab Runner SSH private key for executors
      become: true
      ansible.builtin.copy:
        src: id_rsa
        dest: /etc/gitlab-runner/id_rsa
        mode: "0600"
        owner: gitlab-runner
        group: gitlab-runner
      no_log: true
    - name: Gitlab Runner Restart
      become: true
      ansible.builtin.service:
        name: gitlab-runner
        state: restarted
      when: gitlab_runner_config.changed
